Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 4333)
@@ -45,7 +45,6 @@
    PUBLIC   lim_itd_shiftice
 
-   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
-   REAL(wp) ::   epsi13 = 1.e-13_wp   !
    REAL(wp) ::   epsi10 = 1.e-10_wp   !
+   REAL(wp) ::   epsi06 = 1.e-6_wp   !
 
    !!----------------------------------------------------------------------
@@ -110,22 +109,5 @@
       CALL lim_var_glo2eqv    ! only for info
 
-      !----------------------------------------------------------------------------------------
-      !  4) Computation of trend terms and get back to old values      
-      !----------------------------------------------------------------------------------------
-
-      !- Trend terms
-      d_a_i_thd(:,:,:)   = a_i(:,:,:)   - old_a_i(:,:,:) 
-      d_v_s_thd(:,:,:)   = v_s(:,:,:)   - old_v_s(:,:,:)
-      d_v_i_thd(:,:,:)   = v_i(:,:,:)   - old_v_i(:,:,:)  
-      d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
-      d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
-      !?? d_oa_i_thd(:,:,:)  = oa_i (:,:,:) - old_oa_i (:,:,:)
-      d_smv_i_thd(:,:,:) = 0._wp
-      IF( num_sal == 2 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
-
-      ! diag only (clem)
-      dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) * r1_rdtice * rday
-
-      IF(ln_ctl) THEN   ! Control print
+     IF(ln_ctl) THEN   ! Control print
          CALL prt_ctl_info(' ')
          CALL prt_ctl_info(' - Cell values : ')
@@ -183,14 +165,5 @@
       ! -------------------------------
       !
-      !- Recover Old values
-      a_i(:,:,:)   = old_a_i (:,:,:)
-      v_s(:,:,:)   = old_v_s (:,:,:)
-      v_i(:,:,:)   = old_v_i (:,:,:)
-      e_s(:,:,:,:) = old_e_s (:,:,:,:)
-      e_i(:,:,:,:) = old_e_i (:,:,:,:)
-      !?? oa_i(:,:,:)  = old_oa_i(:,:,:)
-      IF( num_sal == 2 )   smv_i(:,:,:) = old_smv_i(:,:,:)
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('limitd_th')
+     IF( nn_timing == 1 )  CALL timing_stop('limitd_th')
    END SUBROUTINE lim_itd_th
    !
@@ -281,9 +254,9 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-a_i(ji,jj,jl)+epsi10))     !0 if no ice and 1 if yes
-               ht_i(ji,jj,jl)    = v_i(ji,jj,jl) / MAX(a_i(ji,jj,jl),epsi10) * zindb
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-old_a_i(ji,jj,jl)+epsi10)) !0 if no ice and 1 if yes
-               zht_i_o(ji,jj,jl) = old_v_i(ji,jj,jl) / MAX(old_a_i(ji,jj,jl),epsi10) * zindb
-               IF( a_i(ji,jj,jl) > 1e-6 )   zdhice(ji,jj,jl) = ht_i(ji,jj,jl) - zht_i_o(ji,jj,jl) 
+               zindb             = 1.0 - MAX( 0.0, SIGN( 1.0, - a_i(ji,jj,jl) + epsi10 ) )     !0 if no ice and 1 if yes
+               ht_i(ji,jj,jl)    = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb
+               zindb             = 1.0 - MAX( 0.0, SIGN( 1.0, - old_a_i(ji,jj,jl) + epsi10) ) !0 if no ice and 1 if yes
+               zht_i_o(ji,jj,jl) = old_v_i(ji,jj,jl) / MAX( old_a_i(ji,jj,jl), epsi10 ) * zindb
+               IF( a_i(ji,jj,jl) > epsi06 )   zdhice(ji,jj,jl) = ht_i(ji,jj,jl) - zht_i_o(ji,jj,jl) 
             END DO
          END DO
@@ -329,6 +302,6 @@
             ij = nind_j(ji)
             !
-            IF ( ( zht_i_o(ii,ij,jl)  .GT.epsi10 ) .AND. & 
-               ( zht_i_o(ii,ij,jl+1).GT.epsi10 ) ) THEN
+            IF ( ( zht_i_o(ii,ij,jl) .GT. epsi10 ) .AND. & 
+               ( zht_i_o(ii,ij,jl+1) .GT. epsi10 ) ) THEN
                !interpolate between adjacent category growth rates
                zslope = ( zdhice(ii,ij,jl+1)     - zdhice(ii,ij,jl) ) / &
@@ -449,5 +422,5 @@
                      * a_i(ii,ij,klbnd) / ( a_i(ii,ij,klbnd) - zda0 )
                   a_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd) - zda0
-                  v_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd)*ht_i(ii,ij,klbnd) ! clem@useless ?
+                  v_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd)*ht_i(ii,ij,klbnd) ! clem-useless ?
                ENDIF     ! zetamax > 0
                ! ji, a_i > epsi10
@@ -541,5 +514,5 @@
             a_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) / hiclim 
             ht_i(ii,ij,1) = hiclim
-            v_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) !clem@useless
+            v_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) !clem-useless
          ENDIF
       END DO !ji
@@ -604,13 +577,11 @@
       REAL(wp) ::   zdhr         ! 1 / (hR - hL)
       REAL(wp) ::   zwk1, zwk2   ! temporary variables
-      REAL(wp) ::   zacrith      ! critical minimum concentration in an ice category
-      !!------------------------------------------------------------------
-      !
-      zacrith       = 1.0e-6
+      !!------------------------------------------------------------------
+      !
       !
       DO jj = 1, jpj
          DO ji = 1, jpi
             !
-            IF( zremap_flag(ji,jj) == 1 .AND. a_i(ji,jj,num_cat) > zacrith   &
+            IF( zremap_flag(ji,jj) == 1 .AND. a_i(ji,jj,num_cat) > epsi10   &
                &                        .AND. hice(ji,jj)        > 0._wp     ) THEN
 
@@ -1015,5 +986,5 @@
                   ! end TECLIM change 
                   ! clem: how much of a_i you send in cat sup is somewhat arbitrary
-                  zdaice(ji,jj,jl)  = a_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - hi_max(jl) ) / ht_i(ji,jj,jl)  
+                  zdaice(ji,jj,jl)  = a_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - hi_max(jl) + epsi10 ) / ht_i(ji,jj,jl)  
                   zdvice(ji,jj,jl)  = v_i(ji,jj,jl) - ( a_i(ji,jj,jl) - zdaice(ji,jj,jl) ) * ( hi_max(jl) - epsi10 )
                ENDIF
@@ -1043,26 +1014,40 @@
          zshiftflag = 0
 
+!clem-change
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               IF( a_i(ji,jj,jl+1) >  epsi10 .AND.   &
+!                  ht_i(ji,jj,jl+1) <= hi_max(jl) ) THEN
+!                  !
+!                  zshiftflag = 1
+!                  zdonor(ji,jj,jl) = jl + 1
+!                  zdaice(ji,jj,jl) = a_i(ji,jj,jl+1) 
+!                  zdvice(ji,jj,jl) = v_i(ji,jj,jl+1)
+!               ENDIF
+!            END DO                 ! ji
+!         END DO                 ! jj
+!
+!         IF(lk_mpp)   CALL mpp_max( zshiftflag )
+!         
+!         IF( zshiftflag == 1 ) THEN            ! Shift ice between categories
+!            CALL lim_itd_shiftice( klbnd, kubnd, zdonor, zdaice, zdvice )
+!            ! Reset shift parameters
+!            zdonor(:,:,jl) = 0
+!            zdaice(:,:,jl) = 0._wp
+!            zdvice(:,:,jl) = 0._wp
+!         ENDIF
+!clem-change
+
+         ! clem-change begin: why not doing that?
          DO jj = 1, jpj
             DO ji = 1, jpi
                IF( a_i(ji,jj,jl+1) >  epsi10 .AND.   &
                   ht_i(ji,jj,jl+1) <= hi_max(jl) ) THEN
-                  !
-                  zshiftflag = 1
-                  zdonor(ji,jj,jl) = jl + 1
-                  zdaice(ji,jj,jl) = a_i(ji,jj,jl+1) 
-                  zdvice(ji,jj,jl) = v_i(ji,jj,jl+1)
+                  ht_i(ji,jj,jl+1) = hi_max(jl) + epsi10
+                  a_i (ji,jj,jl+1) = v_i(ji,jj,jl+1) / ht_i(ji,jj,jl+1) 
                ENDIF
             END DO                 ! ji
          END DO                 ! jj
-
-         IF(lk_mpp)   CALL mpp_max( zshiftflag )
-         
-         IF( zshiftflag == 1 ) THEN            ! Shift ice between categories
-            CALL lim_itd_shiftice( klbnd, kubnd, zdonor, zdaice, zdvice )
-            ! Reset shift parameters
-            zdonor(:,:,jl) = 0
-            zdaice(:,:,jl) = 0._wp
-            zdvice(:,:,jl) = 0._wp
-         ENDIF
+         ! clem-change end
 
       END DO                    ! jl
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 4333)
@@ -50,4 +50,5 @@
    PUBLIC   lim_rhg        ! routine called by lim_dyn (or lim_dyn_2)
 
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !
    REAL(wp) ::   rzero   = 0._wp   ! constant values
    REAL(wp) ::   rone    = 1._wp   ! constant values
@@ -426,17 +427,17 @@
                !-Calculate stress tensor components zs1 and zs2 
                !-at centre of grid cells (see section 3.5 of CICE user's guide).
-               !zs1(ji,jj) = ( zs1(ji,jj) - dtotel*( ( 1._wp - alphaevp) * zs1(ji,jj) +   &
-               !   &          ( delta / deltat(ji,jj) - zdd(ji,jj) / deltat(ji,jj) ) * zpresh(ji,jj) ) )  &       
-               !   &          / ( 1._wp + alphaevp * dtotel )
-
-               !zs2(ji,jj) = ( zs2(ji,jj) - dtotel * ( ( 1._wp - alphaevp ) * ecc2 * zs2(ji,jj) -   &
-               !              zdt(ji,jj) / deltat(ji,jj) * zpresh(ji,jj) ) )   &
-               !   &          / ( 1._wp + alphaevp * ecc2 * dtotel )
+               zs1(ji,jj) = ( zs1(ji,jj) - dtotel*( ( 1._wp - alphaevp) * zs1(ji,jj) +   &
+                  &          ( delta / deltat(ji,jj) - zdd(ji,jj) / deltat(ji,jj) ) * zpresh(ji,jj) ) )  &       
+                  &          / ( 1._wp + alphaevp * dtotel )
+
+               zs2(ji,jj) = ( zs2(ji,jj) - dtotel * ( ( 1._wp - alphaevp ) * ecc2 * zs2(ji,jj) -   &
+                             zdt(ji,jj) / deltat(ji,jj) * zpresh(ji,jj) ) )   &
+                  &          / ( 1._wp + alphaevp * ecc2 * dtotel )
 
                ! new formulation from S. Bouillon to help stabilizing the code (no need of alphaevp)
-               zs1(ji,jj) = ( zs1(ji,jj) + dtotel * ( ( zdd(ji,jj) / deltat(ji,jj) - delta / deltat(ji,jj) )  &
-                  &         * zpresh(ji,jj) ) ) / ( 1._wp + dtotel )
-               zs2(ji,jj) = ( zs2(ji,jj) + dtotel * ( ecci * zdt(ji,jj) / deltat(ji,jj) * zpresh(ji,jj) ) )  &
-                  &         / ( 1._wp + dtotel )
+               !zs1(ji,jj) = ( zs1(ji,jj) + dtotel * ( ( zdd(ji,jj) / deltat(ji,jj) - delta / deltat(ji,jj) )  &
+               !   &         * zpresh(ji,jj) ) ) / ( 1._wp + dtotel )
+               !zs2(ji,jj) = ( zs2(ji,jj) + dtotel * ( ecci * zdt(ji,jj) / deltat(ji,jj) * zpresh(ji,jj) ) )  &
+               !   &         / ( 1._wp + dtotel )
 
             END DO
@@ -472,12 +473,12 @@
 
                !-Calculate stress tensor component zs12 at corners (see section 3.5 of CICE user's guide).
-               !zs12(ji,jj) = ( zs12(ji,jj) - dtotel * ( (1.0-alphaevp) * ecc2 * zs12(ji,jj) - zds(ji,jj) /  &
-               !   &          ( 2._wp * deltac(ji,jj) ) * zpreshc(ji,jj) ) )  &
-               !   &          / ( 1._wp + alphaevp * ecc2 * dtotel ) 
+               zs12(ji,jj) = ( zs12(ji,jj) - dtotel * ( (1.0-alphaevp) * ecc2 * zs12(ji,jj) - zds(ji,jj) /  &
+                  &          ( 2._wp * deltac(ji,jj) ) * zpreshc(ji,jj) ) )  &
+                  &          / ( 1._wp + alphaevp * ecc2 * dtotel ) 
 
                ! new formulation from S. Bouillon to help stabilizing the code (no need of alphaevp)
-               zs12(ji,jj) = ( zs12(ji,jj) + dtotel *  &
-                  &          ( ecci * zds(ji,jj) / ( 2._wp * deltac(ji,jj) ) * zpreshc(ji,jj) ) )  &
-                  &          / ( 1.0 + dtotel ) 
+               !zs12(ji,jj) = ( zs12(ji,jj) + dtotel *  &
+               !   &          ( ecci * zds(ji,jj) / ( 2._wp * deltac(ji,jj) ) * zpreshc(ji,jj) ) )  &
+               !   &          / ( 1.0 + dtotel ) 
 
             END DO ! ji
@@ -485,12 +486,4 @@
 
          CALL lbc_lnk( zs12(:,:), 'F', 1. )
-
-!#if defined key_bdy
-!         ! clem: change zs1, zs2, zs12 at the boundary for each iteration
-!         CALL bdy_ice_lim_dyn( 2, zs1, zs2, zs12 )
-!         CALL lbc_lnk( zs1 (:,:), 'T', 1. )
-!         CALL lbc_lnk( zs2 (:,:), 'T', 1. )
-!         CALL lbc_lnk( zs12(:,:), 'F', 1. )
-!#endif         
 
          ! Ice internal stresses (Appendix C of Hunke and Dukowicz, 2002)
@@ -544,4 +537,8 @@
             CALL agrif_rhg_lim2( jter, nevp, 'U' )
 #endif
+#if defined key_bdy
+         ! clem: change u_ice and v_ice at the boundary for each iteration
+         CALL bdy_ice_lim_dyn( 'U' )
+#endif         
 
 !CDIR NOVERRCHK
@@ -572,4 +569,8 @@
             CALL agrif_rhg_lim2( jter, nevp, 'V' )
 #endif
+#if defined key_bdy
+         ! clem: change u_ice and v_ice at the boundary for each iteration
+         CALL bdy_ice_lim_dyn( 'V' )
+#endif         
 
          ELSE 
@@ -599,6 +600,10 @@
             CALL lbc_lnk( v_ice(:,:), 'V', -1. )
 #if defined key_agrif && defined key_lim2
-            CALL agrif_rhg_lim2( jter, nevp , 'V' )
-#endif
+            CALL agrif_rhg_lim2( jter, nevp, 'V' )
+#endif
+#if defined key_bdy
+         ! clem: change u_ice and v_ice at the boundary for each iteration
+         CALL bdy_ice_lim_dyn( 'V' )
+#endif         
 
 !CDIR NOVERRCHK
@@ -632,12 +637,11 @@
             CALL agrif_rhg_lim2( jter, nevp, 'U' )
 #endif
+#if defined key_bdy
+         ! clem: change u_ice and v_ice at the boundary for each iteration
+         CALL bdy_ice_lim_dyn( 'U' )
+#endif         
 
          ENDIF
          
-!#if defined key_bdy
-!         ! clem: change u_ice and v_ice at the boundary for each iteration
-!         CALL bdy_ice_lim_dyn( 1 )
-!#endif         
-
          IF(ln_ctl) THEN
             !---  Convergence test.
@@ -666,6 +670,6 @@
 !CDIR NOVERRCHK
          DO ji = fs_2, fs_jpim1
-            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
-            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
+            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - epsi10 ) ) 
+            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , epsi10 )
             zdummy = vt_i(ji,jj)
             IF ( zdummy .LE. hminrhg ) THEN
@@ -684,11 +688,12 @@
 #if defined key_bdy
       ! clem: change u_ice and v_ice at the boundary
-      CALL bdy_ice_lim_dyn( 1 )
+      CALL bdy_ice_lim_dyn( 'U' )
+      CALL bdy_ice_lim_dyn( 'V' )
 #endif         
 
       DO jj = k_j1+1, k_jpj-1 
          DO ji = fs_2, fs_jpim1
-            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
-            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
+            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - epsi10 ) ) 
+            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , epsi10 )
             zdummy = vt_i(ji,jj)
             IF ( zdummy .LE. hminrhg ) THEN
@@ -714,6 +719,6 @@
             !- zdd(:,:), zdt(:,:): divergence and tension at centre 
             !- zds(:,:): shear on northeast corner of grid cells
-            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
-            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
+            zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - epsi10 ) ) 
+            !zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , epsi10 )
             zdummy = vt_i(ji,jj)
             IF ( zdummy .LE. hminrhg ) THEN
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 4333)
@@ -51,5 +51,4 @@
    PUBLIC   lim_sbc_tau    ! called by sbc_ice_lim
 
-   REAL(wp)  ::   epsi16 = 1.e-16_wp   ! constant values
    REAL(wp)  ::   rzero  = 0._wp    
    REAL(wp)  ::   rone   = 1._wp
@@ -147,5 +146,5 @@
 
             !   computation the solar flux at ocean surface
-            IF (lk_cpl) THEN ! be carfeful: not being tested yet
+            IF (lk_cpl) THEN ! be carfeful: not been tested yet
                ! original line
                !zfcm1 = qsr_tot(ji,jj) + fstric(ji,jj) * at_i(ji,jj)
@@ -190,33 +189,4 @@
             qns(ji,jj) = zfcm2 - fdtcn(ji,jj)                        ! non solar heat flux
             !                           ! fdtcn : turbulent oceanic heat flux
-
-            !!gm   this IF prevents the vertorisation of the whole loop
-          !  IF ( ( ji == jiindx ) .AND. ( jj == jjindx) ) THEN
-          !     WRITE(numout,*) ' lim_sbc : heat fluxes '
-          !     WRITE(numout,*) ' qsr       : ', qsr(jiindx,jjindx)
-          !     WRITE(numout,*) ' pfrld     : ', pfrld(jiindx,jjindx)
-          !     WRITE(numout,*) ' fstric    : ', fstric (jiindx,jjindx)
-          !     WRITE(numout,*)
-          !     WRITE(numout,*) ' qns       : ', qns(jiindx,jjindx)
-          !     WRITE(numout,*) ' fdtcn     : ', fdtcn(jiindx,jjindx)
-          !     WRITE(numout,*) ' ifral     : ', ifral
-          !     WRITE(numout,*) ' ial       : ', ial  
-          !     WRITE(numout,*) ' qcmif     : ', qcmif(jiindx,jjindx)
-          !     WRITE(numout,*) ' qldif     : ', qldif(jiindx,jjindx)
-          !     !WRITE(numout,*) ' qcmif / dt: ', qcmif(jiindx,jjindx) * r1_rdtice
-          !     !WRITE(numout,*) ' qldif / dt: ', qldif(jiindx,jjindx) * r1_rdtice
-          !     WRITE(numout,*) ' ifrdv     : ', ifrdv
-          !     WRITE(numout,*) ' qfvbq     : ', qfvbq(jiindx,jjindx)
-          !     WRITE(numout,*) ' qdtcn     : ', qdtcn(jiindx,jjindx)
-          !     !WRITE(numout,*) ' qfvbq / dt: ', qfvbq(jiindx,jjindx) * r1_rdtice
-          !     !WRITE(numout,*) ' qdtcn / dt: ', qdtcn(jiindx,jjindx) * r1_rdtice
-          !     WRITE(numout,*) ' '
-          !     WRITE(numout,*) ' fdtcn     : ', fdtcn(jiindx,jjindx)
-          !     WRITE(numout,*) ' fhmec     : ', fhmec(jiindx,jjindx)
-          !     WRITE(numout,*) ' fheat_mec : ', fheat_mec(jiindx,jjindx)
-          !     WRITE(numout,*) ' fhbri     : ', fhbri(jiindx,jjindx)
-          !     WRITE(numout,*) ' fheat_res : ', fheat_res(jiindx,jjindx)
-          !  ENDIF
-            !!gm   end
          END DO
       END DO
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 4333)
@@ -50,9 +50,5 @@
    PUBLIC   lim_thd_init   ! called by iceini module
 
-   REAL(wp) ::   epsi20 = 1e-20_wp   ! constant values
-   REAL(wp) ::   epsi16 = 1e-16_wp   !
-   REAL(wp) ::   epsi10 = 1e-10_wp   !
-   REAL(wp) ::   epsi06 = 1e-06_wp   !
-   REAL(wp) ::   epsi04 = 1e-04_wp   !
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !
    REAL(wp) ::   zzero  = 0._wp      !
    REAL(wp) ::   zone   = 1._wp      !
@@ -126,7 +122,7 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_i(ji,jj,jl) , epsi06 ) ) * REAL( nlay_i )
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_i(ji,jj,jl) , epsi10 ) ) * REAL( nlay_i )
                   !0 if no ice and 1 if yes
-                  zindb = 1.0 - MAX(  0.0 , SIGN( 1.0 , - ht_i(ji,jj,jl) )  ) 
+                  zindb = 1.0 - MAX(  0.0 , SIGN( 1.0 , - v_i(ji,jj,jl) + epsi10 )  )
                   !convert units ! very important that this line is here
                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * unit_fac * zindb 
@@ -138,7 +134,7 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi06 ) ) * REAL( nlay_s )
+                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi10 ) ) * REAL( nlay_s )
                   !0 if no ice and 1 if yes
-                  zindb = 1.0 - MAX(  0.0 , SIGN( 1.0 , - ht_s(ji,jj,jl) )  ) 
+                  zindb = 1.0 - MAX(  0.0 , SIGN( 1.0 , - v_s(ji,jj,jl) + epsi10 )  )
                   !convert units ! very important that this line is here
                   e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * unit_fac * zindb 
@@ -147,21 +143,4 @@
          END DO
       END DO
-
-      !-----------------------------
-      ! 1.3) Set some dummies to 0
-      !-----------------------------
-      !clem rdvosif(:,:) = 0.e0   ! variation of ice volume at surface
-      !clem rdvobif(:,:) = 0.e0   ! variation of ice volume at bottom
-      !clem fdvolif(:,:) = 0.e0   ! total variation of ice volume
-      !clem rdvonif(:,:) = 0.e0   ! lateral variation of ice volume
-      !clem fstric (:,:) = 0.e0   ! part of solar radiation transmitted through the ice
-      !clem ffltbif(:,:) = 0.e0   ! linked with fstric
-      !clem qfvbq  (:,:) = 0.e0   ! linked with fstric
-      !clem rdm_snw(:,:) = 0.e0   ! variation of snow mass per unit area
-      !clem rdm_ice(:,:) = 0.e0   ! variation of ice mass per unit area
-      !clem hicifp (:,:) = 0.e0   ! daily thermodynamic ice production. 
-      !clem sfx_bri(:,:) = 0.e0   ! brine flux contribution to salt flux to the ocean
-      !clem fhbri  (:,:) = 0.e0   ! brine flux contribution to heat flux to the ocean
-      !clem sfx_thd(:,:) = 0.e0   ! equivalent salt flux to the ocean due to ice/growth decay
 
       !-----------------------------------
@@ -182,7 +161,5 @@
 !CDIR NOVERRCHK
          DO ji = 1, jpi
-            phicif(ji,jj)  = vt_i(ji,jj)
-            pfrld(ji,jj)   = 1.0 - at_i(ji,jj)
-            zinda          = tms(ji,jj) * ( 1.0 - MAX( zzero , SIGN( zone , - at_i(ji,jj) ) ) )
+            zinda          = tms(ji,jj) * ( 1.0 - MAX( zzero , SIGN( zone , - at_i(ji,jj) + epsi10 ) ) )
             !
             !           !  solar irradiance transmission at the mixed layer bottom and used in the lead heat budget
@@ -195,8 +172,8 @@
 
             ! here the drag will depend on ice thickness and type (0.006)
-            fdtcn(ji,jj)  = zinda * rau0 * rcp * 0.006  * zfric_u * ( (sst_m(ji,jj) + rt0) - t_bo(ji,jj) ) 
+            fdtcn(ji,jj)  = zinda * rau0 * rcp * 0.006  * zfric_u * ( ( sst_m(ji,jj) + rt0 ) - t_bo(ji,jj) ) 
             ! also category dependent
             !           !-- Energy from the turbulent oceanic heat flux heat flux coming in the lead 
-            qdtcn(ji,jj)  = zinda * fdtcn(ji,jj) * (1.0 - at_i(ji,jj)) * rdt_ice
+            qdtcn(ji,jj)  = zinda * fdtcn(ji,jj) * ( 1.0 - at_i(ji,jj) ) * rdt_ice
             !                       
             !           !-- Lead heat budget, qldif (part 1, next one is in limthd_dh) 
@@ -214,5 +191,5 @@
             zpareff        = 1.0 - zinda * zfntlat
             != 0 if ice and positive heat budget and 1 if one of those two is false
-            zqlbsbq(ji,jj) = qldif(ji,jj) * ( 1.0 - zpareff ) / MAX( at_i(ji,jj) * rdt_ice , epsi16 )
+            zqlbsbq(ji,jj) = qldif(ji,jj) * ( 1.0 - zpareff ) / ( rdt_ice * MAX( at_i(ji,jj), epsi10 ) )
             !
             ! Heat budget of the lead, energy transferred from ice to ocean
@@ -221,8 +198,8 @@
             !
             ! Energy needed to bring ocean surface layer until its freezing (qcmif, limflx)
-            qcmif  (ji,jj) =  rau0 * rcp * fse3t_m(ji,jj) * ( t_bo(ji,jj) - (sst_m(ji,jj) + rt0) )
+            qcmif  (ji,jj) =  rau0 * rcp * fse3t_m(ji,jj) * ( t_bo(ji,jj) - ( sst_m(ji,jj) + rt0 ) )
             !
             ! oceanic heat flux (limthd_dh)
-            fbif   (ji,jj) = zinda * (  fsbbq(ji,jj) / MAX( at_i(ji,jj) , epsi20 ) + fdtcn(ji,jj) )
+            fbif   (ji,jj) = zinda * (  fsbbq(ji,jj) / MAX( at_i(ji,jj) , epsi10 ) + fdtcn(ji,jj) )
             !
          END DO
@@ -240,5 +217,5 @@
          ENDIF
 
-         zareamin = 1.e-10
+         zareamin = epsi10
          nbpb = 0
          DO jj = 1, jpj
@@ -248,10 +225,16 @@
                   npb(nbpb) = (jj - 1) * jpi + ji
                ENDIF
-               ! debug point to follow
-               IF ( (ji.eq.jiindx).AND.(jj.eq.jjindx) ) THEN
-                  jiindex_1d = nbpb
-               ENDIF
-            END DO
-         END DO
+            END DO
+         END DO
+
+         ! debug point to follow
+         jiindex_1d = 0
+         IF( ln_nicep ) THEN
+            DO ji = mi0(jiindx), mi1(jiindx)
+               DO jj = mj0(jjindx), mj1(jjindx)
+                  jiindex_1d = (jj - 1) * jpi + ji
+               END DO
+            END DO
+         ENDIF
 
          !------------------------------------------------------------------------------!
@@ -315,6 +298,6 @@
             !--------------------------------
 
-            IF( con_i )   CALL lim_thd_enmelt( 1, nbpb )   ! computes sea ice energy of melting
-            IF( con_i )   CALL lim_thd_glohec( qt_i_in, qt_s_in, q_i_layer_in, 1, nbpb, jl )
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_enmelt( 1, nbpb )   ! computes sea ice energy of melting
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_glohec( qt_i_in, qt_s_in, q_i_layer_in, 1, nbpb, jl )
 
             !                                 !---------------------------------!
@@ -324,6 +307,6 @@
             CALL lim_thd_enmelt( 1, nbpb )    ! computes sea ice energy of melting compulsory for limthd_dh
 
-            IF( con_i )   CALL lim_thd_glohec ( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
-            IF( con_i )   CALL lim_thd_con_dif( 1 , nbpb , jl )
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_glohec ( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_con_dif( 1 , nbpb , jl )
 
             !                                 !---------------------------------!
@@ -340,6 +323,6 @@
 
             !           CALL lim_thd_enmelt(1,nbpb)   ! computes sea ice energy of melting
-            IF( con_i )   CALL lim_thd_glohec( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
-            IF( con_i )   CALL lim_thd_con_dh ( 1 , nbpb , jl )
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_glohec( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
+            IF( con_i .AND. jiindex_1d > 0 )   CALL lim_thd_con_dh ( 1 , nbpb , jl )
 
             !--------------------------------
@@ -431,5 +414,5 @@
 !clem@mv-to-itd    dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) * r1_rdtice * rday
 
-      IF( con_i )   fbif(:,:) = fbif(:,:) + zqlbsbq(:,:)
+      IF( con_i .AND. jiindex_1d > 0 )   fbif(:,:) = fbif(:,:) + zqlbsbq(:,:)
 
       IF(ln_ctl) THEN            ! Control print
@@ -522,8 +505,8 @@
       END DO
       !
-      IF(lwp) WRITE(numout,*) ' lim_thd_glohec '
-      IF(lwp) WRITE(numout,*) ' qt_i_in : ', eti(jiindex_1d,jl) * r1_rdtice
-      IF(lwp) WRITE(numout,*) ' qt_s_in : ', ets(jiindex_1d,jl) * r1_rdtice
-      IF(lwp) WRITE(numout,*) ' qt_in   : ', ( eti(jiindex_1d,jl) + ets(jiindex_1d,jl) ) * r1_rdtice
+      WRITE(numout,*) ' lim_thd_glohec '
+      WRITE(numout,*) ' qt_i_in : ', eti(jiindex_1d,jl) * r1_rdtice
+      WRITE(numout,*) ' qt_s_in : ', ets(jiindex_1d,jl) * r1_rdtice
+      WRITE(numout,*) ' qt_in   : ', ( eti(jiindex_1d,jl) + ets(jiindex_1d,jl) ) * r1_rdtice
       !
    END SUBROUTINE lim_thd_glohec
@@ -611,7 +594,7 @@
       WRITE(numout,*) ' Number of points where there is a surf err gt than surf_err : ', numce, numit
 
-      IF (jiindex_1D.GT.0) WRITE(numout,*) ' fc_su      : ', fc_su(jiindex_1d)
-      IF (jiindex_1D.GT.0) WRITE(numout,*) ' fatm       : ', fatm(jiindex_1d,jl)
-      IF (jiindex_1D.GT.0) WRITE(numout,*) ' t_su       : ', t_su_b(jiindex_1d)
+      WRITE(numout,*) ' fc_su      : ', fc_su(jiindex_1d)
+      WRITE(numout,*) ' fatm       : ', fatm(jiindex_1d,jl)
+      WRITE(numout,*) ' t_su       : ', t_su_b(jiindex_1d)
 
       !---------------------------------------
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 4333)
@@ -32,9 +32,9 @@
    PUBLIC   lim_thd_dh   ! called by lim_thd
 
-   REAL(wp) ::   epsi20 = 1e-20   ! constant values
-   REAL(wp) ::   epsi13 = 1e-13   !
-   REAL(wp) ::   epsi16 = 1e-16   !
-   REAL(wp) ::   zzero  = 0.e0    !
-   REAL(wp) ::   zone   = 1.e0    !
+   REAL(wp) ::   epsi20 = 1.e-20   ! constant values
+   REAL(wp) ::   epsi10 = 1.e-10   !
+   REAL(wp) ::   epsi13 = 1.e-13   !
+   REAL(wp) ::   zzero  = 0._wp    !
+   REAL(wp) ::   zone   = 1._wp    !
 
    !!----------------------------------------------------------------------
@@ -125,4 +125,5 @@
       INTEGER  ::   num_iter_max, numce_dh
       REAL(wp) ::   meance_dh
+      REAL(wp) ::   zinda 
       REAL(wp), POINTER, DIMENSION(:) ::   zinnermelt
       REAL(wp), POINTER, DIMENSION(:) ::   zfbase, zdq_i
@@ -288,7 +289,7 @@
       END DO
 
-      !                     !-------------------
-      IF( con_i ) THEN      ! Conservation test
-         !                  !-------------------
+      !                                          !-------------------
+      IF( con_i .AND. jiindex_1d > 0 ) THEN      ! Conservation test
+         !                                       !-------------------
          numce_dh  = 0
          meance_dh = 0._wp
@@ -494,7 +495,7 @@
       END DO ! jk
 
-      !                     !-------------------
-      IF( con_i ) THEN      ! Conservation test
-      !                     !-------------------
+      !                                          !-------------------
+      IF( con_i .AND. jiindex_1d > 0 ) THEN      ! Conservation test
+      !                                          !-------------------
          DO ji = kideb, kiut
             IF(  ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) >= 0.e0  ) THEN
@@ -544,5 +545,6 @@
          sfx_thd_1d(ji)  = sfx_thd_1d(ji) - sm_i_b(ji) * a_i_b(ji) * zdvres * rhoic * r1_rdtice
          !                     ! excessive energy is sent to lateral ablation
-         fsup     (ji) =  rhoic * lfus * at_i_b(ji) / MAX( 1.0 - at_i_b(ji) , epsi13 ) * zdvres * r1_rdtice
+         zinda = MAX( 0._wp, SIGN( 1._wp , 1.0 - at_i_b(ji) - epsi10 ) )
+         fsup(ji) =  zinda * rhoic * lfus * at_i_b(ji) / MAX( 1.0 - at_i_b(ji) , epsi10 ) * zdvres * r1_rdtice
       END DO
 
@@ -577,5 +579,6 @@
 
          ! energy of melting of remaining snow
-         zqt_s(ji) =    ( 1. - zihg ) * zqt_s(ji) / MAX( zhni, epsi13 )
+         zinda = MAX( 0._wp, SIGN( 1._wp , zhni - epsi10 ) )
+         zqt_s(ji) =    ( 1. - zihg ) * zqt_s(ji) / MAX( zhni, epsi10 ) * zinda
          zdhnm     =  - ( 1. - zihg ) * ( 1. - zihgnew ) * zfdt_final(ji) / MAX( zqt_s(ji) , epsi13 )
          zhnfi     =  zhni + zdhnm
@@ -613,5 +616,5 @@
          ENDIF
          !
-         ! diagnostic ( bottom ice growth )
+         ! diagnostic 
          ii = MOD( npb(ji) - 1, jpi ) + 1
          ij = ( npb(ji) - 1 ) / jpi + 1
@@ -689,10 +692,10 @@
          ! clem: new salinity difference stored (to be used in limthd_ent.F90)
          IF (  num_sal == 2  ) THEN
-            i_ice_switch = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - zhgnew(ji) + epsi13 ) )
+            i_ice_switch = MAX( 0._wp , SIGN( 1._wp , zhgnew(ji) - epsi10 ) )
             ! salinity dif due to snow-ice formation
-            dsm_i_si_1d(ji) = ( zsm_snowice - sm_i_b(ji) ) * dh_snowice(ji) / MAX( zhgnew(ji), epsi13 ) * i_ice_switch     
+            dsm_i_si_1d(ji) = ( zsm_snowice - sm_i_b(ji) ) * dh_snowice(ji) / MAX( zhgnew(ji), epsi10 ) * i_ice_switch     
             ! salinity dif due to bottom growth 
             IF (  fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji)  < 0._wp ) THEN
-               dsm_i_se_1d(ji) = ( s_i_new(ji) - sm_i_b(ji) ) * dh_i_bott(ji) / MAX( zhgnew(ji), epsi13 ) * i_ice_switch
+               dsm_i_se_1d(ji) = ( s_i_new(ji) - sm_i_b(ji) ) * dh_i_bott(ji) / MAX( zhgnew(ji), epsi10 ) * i_ice_switch
             ENDIF
          ENDIF
